var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
/*!
* vue3-sketch-ruler v1.2.3
* 2021年11月Fri Nov 12 2021 11:15:56 GMT+0800 (GMT+08:00)
* 制作
*/
import { defineComponent, inject, ref, onMounted, computed, withDirectives, openBlock, createElementBlock, normalizeStyle, createElementVNode, toDisplayString, vShow, reactive, watch, resolveComponent, normalizeClass, createVNode, Fragment, renderList, createBlock, provide, readonly, renderSlot, withCtx } from "vue";
var rulerLine_vue_vue_type_style_index_0_scoped_true_lang = "";
var _export_sfc = (sfc, props) => {
  for (const [key, val] of props) {
    sfc[key] = val;
  }
  return sfc;
};
const _sfc_main$6 = defineComponent({
  name: "LineRuler",
  props: {
    index: Number,
    start: Number,
    vertical: Boolean,
    value: Number
  },
  emits: ["onMouseDown", "onRelease", "onRemove"],
  setup(props, { emit }) {
    const injectObj = inject("sketch");
    const { isShowReferLine, palette, thick } = injectObj;
    const startValue = ref(0);
    const showLine = ref(true);
    onMounted(() => {
      startValue.value = props.value;
    });
    const setShowLine = (offset2) => {
      showLine.value = offset2 >= 0;
    };
    const offset = computed(() => {
      const offset2 = (startValue.value - props.start) * injectObj.scale;
      setShowLine(offset2);
      const positionValue = offset2 + "px";
      const position = props.vertical ? { top: positionValue } : { left: positionValue };
      return position;
    });
    const borderCursor = computed(() => {
      console.log(palette == null ? void 0 : palette.lineColor, "palette.lineColor");
      const borderValue = `1px solid ${palette == null ? void 0 : palette.lineColor}`;
      const border = props.vertical ? { borderTop: borderValue } : { borderLeft: borderValue };
      const cursorValue = isShowReferLine ? props.vertical ? "ns-resize" : "ew-resize" : "none";
      return __spreadValues({
        cursor: cursorValue
      }, border);
    });
    const actionStyle = computed(() => {
      const actionStyle2 = props.vertical ? { left: thick + "px" } : { top: thick + "px" };
      return actionStyle2;
    });
    const handleDown = (e) => {
      const startD = props.vertical ? e.clientY : e.clientX;
      const initValue = startValue.value;
      emit("onMouseDown");
      const onMove = (e2) => {
        const currentD = props.vertical ? e2.clientY : e2.clientX;
        const newValue = Math.round(initValue + (currentD - startD) / injectObj.scale);
        startValue.value = newValue;
      };
      const onEnd = () => {
        emit("onRelease", startValue.value, props.index);
        document.removeEventListener("mousemove", onMove);
        document.removeEventListener("mouseup", onEnd);
      };
      document.addEventListener("mousemove", onMove);
      document.addEventListener("mouseup", onEnd);
    };
    const handleRemove = () => {
      emit("onRemove", props.index);
    };
    return {
      startValue,
      showLine,
      offset,
      borderCursor,
      actionStyle,
      handleDown,
      handleRemove
    };
  }
});
const _hoisted_1$4 = { class: "value" };
function _sfc_render$6(_ctx, _cache, $props, $setup, $data, $options) {
  return withDirectives((openBlock(), createElementBlock("div", {
    class: "line",
    style: normalizeStyle([_ctx.offset, _ctx.borderCursor]),
    onMousedown: _cache[1] || (_cache[1] = (...args) => _ctx.handleDown && _ctx.handleDown(...args))
  }, [
    createElementVNode("div", {
      class: "action",
      style: normalizeStyle(_ctx.actionStyle)
    }, [
      createElementVNode("span", {
        class: "del",
        onClick: _cache[0] || (_cache[0] = (...args) => _ctx.handleRemove && _ctx.handleRemove(...args))
      }, "\xD7"),
      createElementVNode("span", _hoisted_1$4, toDisplayString(_ctx.startValue), 1)
    ], 4)
  ], 36)), [
    [vShow, _ctx.showLine]
  ]);
}
var RulerLine = /* @__PURE__ */ _export_sfc(_sfc_main$6, [["render", _sfc_render$6], ["__scopeId", "data-v-6caa09a3"]]);
const getGridSize = (scale) => {
  if (scale <= 0.25)
    return 40;
  if (scale <= 0.5)
    return 20;
  if (scale <= 1)
    return 10;
  if (scale <= 2)
    return 5;
  if (scale <= 4)
    return 2;
  return 1;
};
const FONT_SCALE = 0.83;
const drawCavaseRuler = (ctx, start, options, h) => {
  const { scale, width, height, palette } = options;
  const { bgColor, fontColor, ratio, longfgColor, shortfgColor } = palette;
  ctx.scale(ratio, ratio);
  ctx.clearRect(0, 0, width, height);
  ctx.fillStyle = bgColor;
  ctx.fillRect(0, 0, width, height);
  const gridSize = getGridSize(scale);
  const gridPixel = gridSize * scale;
  const gridSize10 = gridSize * 10;
  const gridPixel10 = gridSize10 * scale;
  const startValue = Math.floor(start / gridSize) * gridSize;
  const startValue10 = Math.floor(start / gridSize10) * gridSize10;
  const offsetX = (startValue - start) / gridSize * gridPixel;
  const offsetX10 = (startValue10 - start) / gridSize10 * gridPixel10;
  const endValue = start + Math.ceil((h ? width : height) / scale);
  ctx.beginPath();
  ctx.fillStyle = fontColor;
  ctx.strokeStyle = longfgColor;
  for (let value = startValue10, count = 0; value < endValue; value += gridSize10, count++) {
    const x = offsetX10 + count * gridPixel10 + 0.5;
    h ? ctx.moveTo(x, 0) : ctx.moveTo(0, x);
    ctx.save();
    h ? ctx.translate(x, height * 0.4) : ctx.translate(width * 0.4, x);
    if (!h) {
      ctx.rotate(-Math.PI / 2);
    }
    ctx.scale(FONT_SCALE / ratio, FONT_SCALE / ratio);
    ctx.fillText(value.toString(), 4 * ratio, 7 * ratio);
    ctx.restore();
    h ? ctx.lineTo(x, height * 9 / 16) : ctx.lineTo(width * 9 / 16, x);
  }
  ctx.stroke();
  ctx.closePath();
  ctx.beginPath();
  ctx.strokeStyle = shortfgColor;
  for (let value = startValue, count = 0; value < endValue; value += gridSize, count++) {
    const x = offsetX + count * gridPixel + 0.5;
    h ? ctx.moveTo(x, 0) : ctx.moveTo(0, x);
    if (value % gridSize10 !== 0) {
      h ? ctx.lineTo(x, height * 1 / 4) : ctx.lineTo(width * 1 / 4, x);
    }
  }
  ctx.stroke();
  ctx.closePath();
  ctx.setTransform(1, 0, 0, 1, 0, 0);
};
const _sfc_main$5 = defineComponent({
  name: "CanvasRuler",
  props: {
    showIndicator: Boolean,
    valueNum: Number,
    vertical: Boolean,
    start: Number,
    width: Number,
    height: Number
  },
  emits: ["onAddLine", "update:showIndicator", "update:valueNum"],
  setup(props, { emit }) {
    const injectObj = inject("sketch");
    const { ratio, palette } = injectObj;
    const state = reactive({
      canvasContext: null
    });
    const canvas = ref(null);
    onMounted(() => {
      initCanvasRef();
      updateCanvasContext();
      drawRuler();
    });
    const initCanvasRef = () => {
      state.canvasContext = canvas.value && canvas.value.getContext("2d");
    };
    const updateCanvasContext = () => {
      if (canvas.value) {
        canvas.value.width = props.width * ratio;
        canvas.value.height = props.height * ratio;
        const ctx = state.canvasContext;
        if (ctx) {
          ctx.font = `${12 * ratio}px -apple-system,
                "Helvetica Neue", ".SFNSText-Regular",
                "SF UI Text", Arial, "PingFang SC", "Hiragino Sans GB",
                "Microsoft YaHei", "WenQuanYi Zen Hei", sans-serif`;
          ctx.lineWidth = 1;
          ctx.textBaseline = "middle";
        }
      }
    };
    const drawRuler = () => {
      console.log(injectObj.scale, " canvas.value");
      const options = {
        scale: injectObj.scale,
        width: props.width,
        height: props.height,
        palette
      };
      if (state.canvasContext) {
        drawCavaseRuler(state.canvasContext, props.start, options, !props.vertical);
      }
    };
    watch(() => props.start, () => drawRuler());
    watch([() => props.width, () => props.height], () => {
      updateCanvasContext();
      drawRuler();
    });
    const handle = (e, key) => {
      const getValueByOffset = (offset2, start, scale) => Math.round(start + offset2 / scale);
      const offset = props.vertical ? e.offsetY : e.offsetX;
      const value = getValueByOffset(offset, props.start, injectObj.scale);
      switch (key) {
        case "click":
          emit("onAddLine", value);
          break;
        case "enter":
          emit("update:valueNum", value);
          emit("update:showIndicator", true);
          break;
        default:
          emit("update:valueNum", value);
          break;
      }
    };
    return {
      handle,
      canvas
    };
  }
});
function _sfc_render$5(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("canvas", {
    ref: "canvas",
    class: "ruler",
    onClick: _cache[0] || (_cache[0] = ($event) => _ctx.handle($event, "click")),
    onMouseenter: _cache[1] || (_cache[1] = ($event) => _ctx.handle($event, "enter")),
    onMousemove: _cache[2] || (_cache[2] = ($event) => _ctx.handle($event, "move")),
    onMouseleave: _cache[3] || (_cache[3] = ($event) => _ctx.$emit("update:showIndicator", false))
  }, null, 544);
}
var CanvasRuler = /* @__PURE__ */ _export_sfc(_sfc_main$5, [["render", _sfc_render$5]]);
var rulerWrapper_vue_vue_type_style_index_0_scoped_true_lang = "";
const _sfc_main$4 = defineComponent({
  name: "RulerWrapper",
  components: {
    CanvasRuler,
    RulerLine
  },
  props: {
    vertical: Boolean,
    width: Number,
    height: {
      type: Number
    },
    start: {
      type: Number,
      default: 0
    },
    lines: {
      type: Array,
      default: () => []
    }
  },
  setup(props) {
    const injectObj = inject("sketch");
    const { palette, thick } = injectObj;
    const showIndicator = ref(false);
    const valueNum = ref(0);
    const rwClassName = computed(() => {
      const className = props.vertical ? "v-container" : "h-container";
      return className;
    });
    const rwStyle = computed(() => {
      const hContainer = {
        width: `calc(100% - ${thick}px)`,
        height: `${thick + 1}px`,
        left: `${thick}px`
      };
      const vContainer = {
        width: `${thick && thick + 1}px`,
        height: `calc(100% - ${thick}px)`,
        top: `${thick}px`
      };
      return props.vertical ? vContainer : hContainer;
    });
    const indicatorStyle = computed(() => {
      const indicatorOffset = (valueNum.value - props.start) * injectObj.scale;
      let positionKey = "top";
      let boderKey = "borderLeft";
      positionKey = props.vertical ? "top" : "left";
      boderKey = props.vertical ? "borderBottom" : "borderLeft";
      return {
        [positionKey]: indicatorOffset + "px",
        [boderKey]: `1px solid ${palette == null ? void 0 : palette.lineColor}`
      };
    });
    const handleNewLine = (value) => {
      props.lines.push(value);
    };
    const handleLineRelease = (value, index) => {
      const offset = value - props.start;
      const maxOffset = (props.vertical ? props.height : props.width) / injectObj.scale;
      if (offset < 0 || offset > maxOffset) {
        handleLineRemove(index);
      } else {
        props.lines[index] = value;
      }
    };
    const handleLineRemove = (index) => {
      props.lines.splice(index, 1);
    };
    return {
      injectObj,
      showIndicator,
      valueNum,
      rwClassName,
      rwStyle,
      indicatorStyle,
      handleNewLine,
      handleLineRelease,
      handleLineRemove
    };
  }
});
const _hoisted_1$3 = { class: "lines" };
const _hoisted_2$1 = { class: "value" };
function _sfc_render$4(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_CanvasRuler = resolveComponent("CanvasRuler");
  const _component_RulerLine = resolveComponent("RulerLine");
  return openBlock(), createElementBlock("div", {
    class: normalizeClass(_ctx.rwClassName),
    style: normalizeStyle(_ctx.rwStyle)
  }, [
    createVNode(_component_CanvasRuler, {
      vertical: _ctx.vertical,
      width: _ctx.width,
      height: _ctx.height,
      start: _ctx.start,
      valueNum: _ctx.valueNum,
      "onUpdate:valueNum": _cache[0] || (_cache[0] = ($event) => _ctx.valueNum = $event),
      showIndicator: _ctx.showIndicator,
      "onUpdate:showIndicator": _cache[1] || (_cache[1] = ($event) => _ctx.showIndicator = $event),
      onOnAddLine: _ctx.handleNewLine
    }, null, 8, ["vertical", "width", "height", "start", "valueNum", "showIndicator", "onOnAddLine"]),
    withDirectives(createElementVNode("div", _hoisted_1$3, [
      (openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.lines, (v, i) => {
        return openBlock(), createBlock(_component_RulerLine, {
          key: v + i,
          index: i,
          value: v >> 0,
          start: _ctx.start,
          vertical: _ctx.vertical,
          onOnRemove: _ctx.handleLineRemove,
          onOnRelease: _ctx.handleLineRelease
        }, null, 8, ["index", "value", "start", "vertical", "onOnRemove", "onOnRelease"]);
      }), 128))
    ], 512), [
      [vShow, _ctx.injectObj.isShowReferLine]
    ]),
    withDirectives(createElementVNode("div", {
      class: "indicator",
      style: normalizeStyle(_ctx.indicatorStyle)
    }, [
      createElementVNode("div", _hoisted_2$1, toDisplayString(_ctx.valueNum), 1)
    ], 4), [
      [vShow, _ctx.showIndicator]
    ])
  ], 6);
}
var RulerWrapper = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["render", _sfc_render$4], ["__scopeId", "data-v-8916f644"]]);
const sketchRulerProps = {
  scale: {
    type: Number,
    default: 1
  },
  ratio: {
    type: Number,
    default: 1
  },
  thick: {
    type: Number,
    default: 16
  },
  palette: Object,
  startX: {
    type: Number,
    default: 0
  },
  startY: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 200
  },
  height: {
    type: Number,
    default: 200
  },
  lines: {
    type: Object,
    default: () => {
      return {
        h: [],
        v: []
      };
    }
  },
  cornerActive: {
    type: Boolean,
    default: false
  },
  isShowReferLine: {
    type: Boolean,
    default: true
  }
};
const getPalette = (palette) => {
  function merge(obj, o) {
    Object.keys(obj).forEach((key) => {
      if (key && obj.hasOwnProperty(key)) {
        if (typeof o["key"] === "object") {
          obj[key] = merge(obj[key], o[key]);
        } else if (o.hasOwnProperty(key)) {
          obj[key] = o[key];
        }
      }
    });
    return obj;
  }
  const finalObj = merge({
    bgColor: "rgba(225,225,225, 0)",
    longfgColor: "#BABBBC",
    shortfgColor: "#C8CDD0",
    fontColor: "#7D8694",
    lineColor: "#EB5648",
    borderColor: "#DADADC",
    cornerActiveColor: "rgb(235, 86, 72, 0.6)",
    menu: {
      bgColor: "#fff",
      dividerColor: "#DBDBDB",
      listItem: {
        textColor: "#415058",
        hoverTextColor: "#298DF8",
        disabledTextColor: "rgba(65, 80, 88, 0.4)",
        bgColor: "#fff",
        hoverBgColor: "#F2F2F2"
      }
    }
  }, palette || {});
  return finalObj;
};
var index_vue_vue_type_style_index_0_lang$1 = "";
const _sfc_main$3 = defineComponent({
  name: "SketchRule",
  components: {
    RulerWrapper
  },
  props: sketchRulerProps,
  emits: ["onCornerClick", "handleLine"],
  setup(props, { emit }) {
    const paletteCpu = getPalette(props.palette);
    const cornerActiveClass = computed(() => {
      return props.cornerActive ? " active" : "";
    });
    const cornerStyle = computed(() => {
      return {
        backgroundColor: paletteCpu.bgColor,
        width: props.thick + "px",
        height: props.thick + "px",
        borderRight: `1px solid ${paletteCpu.borderColor}`,
        borderBottom: `1px solid ${paletteCpu.borderColor}`
      };
    });
    const onCornerClick = (e) => {
      console.log(paletteCpu);
      emit("onCornerClick", e);
    };
    const provideObj = reactive({
      thick: props.thick,
      palette: paletteCpu,
      ratio: props.ratio,
      scale: computed(() => props.scale),
      isShowReferLine: props.isShowReferLine
    });
    provide("sketch", readonly(provideObj));
    return {
      cornerActiveClass,
      cornerStyle,
      onCornerClick
    };
  }
});
const _hoisted_1$2 = {
  id: "mb-ruler",
  class: "style-ruler mb-ruler"
};
function _sfc_render$3(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_RulerWrapper = resolveComponent("RulerWrapper");
  return openBlock(), createElementBlock("div", _hoisted_1$2, [
    createVNode(_component_RulerWrapper, {
      vertical: false,
      width: _ctx.width,
      height: _ctx.thick,
      start: _ctx.startX,
      lines: _ctx.lines.h
    }, null, 8, ["width", "height", "start", "lines"]),
    createVNode(_component_RulerWrapper, {
      vertical: true,
      width: _ctx.thick,
      height: _ctx.height,
      start: _ctx.startY,
      lines: _ctx.lines.v
    }, null, 8, ["width", "height", "start", "lines"]),
    createElementVNode("a", {
      class: normalizeClass(["corner", _ctx.cornerActiveClass]),
      style: normalizeStyle(_ctx.cornerStyle),
      onClick: _cache[0] || (_cache[0] = (...args) => _ctx.onCornerClick && _ctx.onCornerClick(...args))
    }, null, 6)
  ]);
}
var SketchRule = /* @__PURE__ */ _export_sfc(_sfc_main$3, [["render", _sfc_render$3]]);
function useHoverElement(target) {
  const isInside = ref(false);
  const x = ref(0);
  const y = ref(0);
  const eleX = ref(0);
  const eleY = ref(0);
  const width = ref(0);
  const height = ref(0);
  const eleRightX = ref(0);
  const eleRightY = ref(0);
  const offsetLeft = ref(0);
  const offsetTop = ref(0);
  watch(target, (el, _preEL, onCleanup) => {
    const moveHandler = (event) => {
      const {
        width: rectWidth,
        height: rectHeight,
        x: rectX,
        y: rectY
      } = el.getBoundingClientRect();
      const scrollTop = document.body.scrollTop || document.documentElement.scrollTop;
      const scrollLeft = document.body.scrollLeft || document.documentElement.scrollLeft;
      x.value = event.pageX;
      y.value = event.pageY;
      offsetLeft.value = scrollLeft + rectX;
      offsetTop.value = scrollTop + rectY;
      width.value = rectWidth;
      height.value = rectHeight;
      isInside.value = false;
      eleX.value = rectX;
      eleY.value = rectY;
      eleRightX.value = eleX.value + rectWidth + scrollLeft;
      eleRightY.value = eleY.value + rectHeight + scrollTop;
      if (x.value > eleX.value && y.value > eleY.value && x.value < eleRightX.value && y.value < eleRightY.value) {
        isInside.value = true;
      }
    };
    const leavehandler = (event) => {
      isInside.value = false;
    };
    el == null ? void 0 : el.addEventListener("mousemove", moveHandler);
    el == null ? void 0 : el.addEventListener("mouseleave", leavehandler);
    onCleanup(() => {
      el == null ? void 0 : el.removeEventListener("mousemove", moveHandler);
      el == null ? void 0 : el.removeEventListener("mouseleave", leavehandler);
    });
  }, { immediate: true });
  return {
    x,
    y,
    eleX,
    eleY,
    width,
    height,
    eleRightX,
    eleRightY,
    isInside,
    offsetLeft,
    offsetTop
  };
}
function getAbsouteOffset(el) {
  let offsetTop = el.offsetTop;
  let offsetLeft = el.offsetLeft;
  while (el.offsetParent) {
    const parent = el.offsetParent;
    el = parent;
    offsetTop += parent.offsetTop;
    offsetLeft += parent.offsetLeft;
  }
  return {
    offsetTop,
    offsetLeft
  };
}
function useElementRect(target) {
  const width = ref(0);
  const height = ref(0);
  const eleX = ref(0);
  const eleY = ref(0);
  const elOffsetTop = ref(0);
  const elOffsetLeft = ref(0);
  watch(target, (el, _preEl) => {
    if (el) {
      document.body.scrollTop || document.documentElement.scrollTop;
      document.body.scrollLeft || document.documentElement.scrollLeft;
      const rect = el.getBoundingClientRect();
      const offsetInfo = getAbsouteOffset(el);
      eleX.value = rect.x;
      eleY.value = rect.y;
      width.value = rect.width;
      height.value = rect.height;
      elOffsetTop.value = offsetInfo.offsetTop;
      elOffsetLeft.value = offsetInfo.offsetLeft;
    }
  }, { immediate: true });
  return {
    width,
    height,
    eleX,
    eleY,
    elOffsetTop,
    elOffsetLeft
  };
}
var magnifyPreview_vue_vue_type_style_index_0_lang = "";
const _sfc_main$2 = {
  props: ["previewImg"],
  components: {},
  setup() {
    const followRef = ref(null);
    const previewWarrperRef = ref(null);
    const { offsetLeft, offsetTop, isInside, width, height, x, y } = useHoverElement(previewWarrperRef);
    const { prveiwInfo, followSize, prevSize, draggleRate } = inject("magnify");
    const followStyle = computed(() => {
      const { width: fWidth, height: fHeight } = useElementRect(followRef);
      const maxLeft = width.value - fWidth.value;
      const maxTop = height.value - fHeight.value;
      let left = x.value - offsetLeft.value - fWidth.value / 2;
      let top = y.value - offsetTop.value - fHeight.value / 2;
      left = left > 0 ? Math.min(left, maxLeft) : 0;
      top = top > 0 ? Math.min(top, maxTop) : 0;
      prveiwInfo.followX = left;
      prveiwInfo.followY = top;
      prveiwInfo.followW = fWidth.value;
      prveiwInfo.followH = fHeight.value;
      prveiwInfo.followMaxX = maxLeft;
      prveiwInfo.followMaxY = maxTop;
      return {
        width: followSize.value.w + "px",
        height: followSize.value.h + "px",
        left: left + "px",
        top: top + "px"
      };
    });
    const wrapperStyle = computed(() => {
      return {
        width: draggleRate * prevSize.w + "px",
        height: draggleRate * prevSize.h + "px"
      };
    });
    return {
      offsetLeft,
      offsetTop,
      x,
      y,
      isInside,
      followRef,
      followStyle,
      previewWarrperRef,
      wrapperStyle
    };
  }
};
const _hoisted_1$1 = /* @__PURE__ */ createElementVNode("i", null, null, -1);
const _hoisted_2 = [
  _hoisted_1$1
];
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", {
    class: "vue-magnify-preview",
    style: normalizeStyle($setup.wrapperStyle),
    ref: "previewWarrperRef"
  }, [
    renderSlot(_ctx.$slots, "default"),
    withDirectives(createElementVNode("span", {
      class: "follow-unit",
      style: normalizeStyle($setup.followStyle),
      ref: "followRef"
    }, _hoisted_2, 4), [
      [vShow, $setup.isInside]
    ])
  ], 4);
}
var MagnifyPreview = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$2]]);
var magnifyZoom_vue_vue_type_style_index_0_lang = "";
const _sfc_main$1 = {
  props: ["zoomImg"],
  setup() {
    const { prveiwInfo, setZoomImgInfo, zoomSize } = inject("magnify");
    const zoomRef = ref(null);
    const imgRef = ref(null);
    const scaleInfo = computed(() => {
      const { width, height } = useElementRect(zoomRef);
      const scaleX = prveiwInfo.followX / prveiwInfo.followMaxX;
      const scaleY = prveiwInfo.followY / prveiwInfo.followMaxY;
      return reactive({
        scaleX,
        scaleY,
        width,
        height
      });
    });
    onMounted(() => {
      if (imgRef.value) {
        imgRef.value.addEventListener("load", function() {
          setZoomImgInfo({ w: this.width, h: this.height });
        });
      }
    });
    watch(scaleInfo, (val) => {
      if (zoomRef.value && imgRef.value) {
        zoomRef.value.scrollTo(val.scaleX * Math.abs(zoomSize.w - imgRef.value.width), val.scaleY * Math.abs(zoomSize.h - imgRef.value.height));
      }
    });
    return {
      prveiwInfo,
      scaleInfo,
      zoomRef,
      imgRef,
      zoomSize
    };
  }
};
const _hoisted_1 = ["src"];
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", {
    class: "vue-magnify-zoom",
    ref: "zoomRef",
    style: normalizeStyle({
      width: $setup.zoomSize.w + "px",
      height: $setup.zoomSize.h + "px",
      right: -$setup.zoomSize.w - 3 + "px"
    })
  }, [
    createElementVNode("img", {
      src: $props.zoomImg,
      ref: "imgRef"
    }, null, 8, _hoisted_1)
  ], 4);
}
var MagnifyZoom = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]);
var index_vue_vue_type_style_index_0_lang = "";
const _sfc_main = defineComponent({
  name: "sketch-ruler-wrapper",
  props: {
    previewImg: {
      type: String,
      required: true
    },
    zoomImg: {
      type: String,
      required: true
    },
    prevSize: {
      type: Object,
      default: () => ({
        width: 450,
        height: 450
      })
    },
    zoomSize: {
      type: Object,
      default: () => null
    },
    draggleRate: {
      type: Number,
      default: 0.3
    }
  },
  emits: ["on-preview-click"],
  components: {
    MagnifyPreview,
    MagnifyZoom
  },
  setup(props, { emit }) {
    const prveiwInfo = reactive({
      followX: 0,
      followY: 0,
      followW: 0,
      followH: 0,
      followMaxX: 0,
      followMaxY: 0
    });
    const zoomImgSize = reactive({
      w: 0,
      h: 0
    });
    const setZoomImgInfo = (v) => {
      zoomImgSize.w = v.w;
      zoomImgSize.h = v.h;
    };
    const followSize = computed(() => {
      return {
        w: 100,
        h: 100
      };
    });
    const previewStyle = computed(() => {
      return {
        width: props.prevSize.w + "px",
        height: props.prevSize.h + "px"
      };
    });
    provide("magnify", {
      prveiwInfo,
      setZoomImgInfo,
      prevSize: props.prevSize,
      followSize,
      zoomSize: props.zoomSize,
      draggleRate: props.draggleRate
    });
    const handleClick = (event) => {
      emit("on-preview-click", event);
    };
    return {
      handleClick,
      prveiwInfo,
      zoomImgSize,
      followSize,
      previewStyle
    };
  }
});
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_magnify_preview = resolveComponent("magnify-preview");
  const _component_magnify_zoom = resolveComponent("magnify-zoom");
  return openBlock(), createElementBlock("section", {
    class: "vue-magnify",
    style: normalizeStyle(_ctx.previewStyle)
  }, [
    createVNode(_component_magnify_preview, { onClick: _ctx.handleClick }, {
      default: withCtx(() => [
        renderSlot(_ctx.$slots, "default")
      ]),
      _: 3
    }, 8, ["onClick"]),
    createVNode(_component_magnify_zoom, { "zoom-img": _ctx.zoomImg }, null, 8, ["zoom-img"])
  ], 4);
}
var SketchRuleWrapper = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
SketchRule.install = (app) => {
  app.component(SketchRule.name, SketchRule);
};
SketchRuleWrapper.install = (app) => {
  app.component(SketchRule.name, SketchRule);
};
export { SketchRule, SketchRuleWrapper, SketchRule as default };
