import type { DefineComponent, ComputedRef, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps } from 'vue';
declare const _default: DefineComponent<{
    /**
     * 展示时的图片
     */
    previewImg: {
        type: StringConstructor;
        required: true;
    };
    /**
     * 放大后的图片
     */
    zoomImg: {
        type: StringConstructor;
        required: true;
    };
    prevSize: {
        type: ObjectConstructor;
        default: () => {
            width: number;
            height: number;
        };
    };
    zoomSize: {
        type: ObjectConstructor;
        default: () => null;
    };
    draggleRate: {
        type: NumberConstructor;
        default: number;
    };
}, {
    handleClick: (event: MouseEvent) => void;
    prveiwInfo: {
        followX: number;
        followY: number;
        followW: number;
        followH: number;
        followMaxX: number;
        followMaxY: number;
    };
    zoomImgSize: {
        w: number;
        h: number;
    };
    followSize: ComputedRef<{
        w: number;
        h: number;
    }>;
    previewStyle: ComputedRef<{
        width: string;
        height: string;
    }>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, "on-preview-click"[], "on-preview-click", VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<{
    previewImg?: unknown;
    zoomImg?: unknown;
    prevSize?: unknown;
    zoomSize?: unknown;
    draggleRate?: unknown;
} & {
    previewImg: string;
    zoomImg: string;
    draggleRate: number;
    prevSize: Record<string, any>;
    zoomSize: Record<string, any>;
} & {}> & {
    "onOn-preview-click"?: ((...args: any[]) => any) | undefined;
}, {
    draggleRate: number;
    prevSize: Record<string, any>;
    zoomSize: Record<string, any>;
}>;
export default _default;
